#TODO Take care of the conversion
%define name module-init-tools
%define version 0.9.11a
%define priority 20
%define release 4mdk
%define ftpurl ftp://ftp.kernel.org/pub/linux/kernel/people/rusty/modules/
%define _prefix /

%define toalternate insmod lsmod modprobe rmmod depmod modinfo

Summary: Tools for managing Linux kernel modules
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{ftpurl}/%{name}-%{version}.tar.bz2
Source1: modprobe.conf
Source2: modprobe.devfs
Source3: modprobe.default
Source4: modprobe.compat
Source5: modprobe.preload
Patch1: module-init-tools-0.9.7-export-gpl.patch.bz2
Patch3: module-init-tools-0.9.11a-probeall.patch.bz2
Patch4: module-init-tools-0.9.11a-modprobe-no_devfsd_hack.patch.bz2
License: GPL
Group: System/Kernel and hardware
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Url: %{ftpurl}
Prereq: /usr/sbin/update-alternatives
Conflicts: modutils < 2.4.22-10mdk devfsd < 1.3.25-31mdk
BuildRequires: glibc-static-devel

%description
This package contains a set of programs for loading, inserting, and
removing kernel modules for Linux (versions 2.5.47 and above). It
serves the same function that the "modutils" package serves for Linux
2.4.

%prep
%setup -q
%patch1 -p1 -b .export-gpl
%patch3 -p1 -b .probeall
%patch4 -p1 -b .no_devfsd_hack

%build
%serverbuild
%configure
%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall transform=

mv $RPM_BUILD_ROOT/bin/lsmod $RPM_BUILD_ROOT/sbin

pushd $RPM_BUILD_ROOT/sbin && {
for i in %{toalternate};do
	mv $i $i-25
done
} && popd

rm -rf $RPM_BUILD_ROOT/%{_mandir}
for n in 5 8;do
	install -d $RPM_BUILD_ROOT/%{_mandir}/man$n/
	for i in *.$n;do
		[[ $n == 8 ]] && ext="-25" || ext=""
		install -m644 $i $RPM_BUILD_ROOT/%{_mandir}/man${n}/${i%%.*}${ext}.$n
	done
done

pushd $RPM_BUILD_ROOT/sbin && {
%ifnarch %{ix86}
	mv insmod.static insmod.static-25
%else
	rm -f insmod.static
%endif
} && popd

install -d -m755 $RPM_BUILD_ROOT/etc/
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc

install -d -m755 $RPM_BUILD_ROOT/lib/module-init-tools
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/lib/module-init-tools
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/lib/module-init-tools

%post
for i in %{toalternate};do
	update-alternatives --install /sbin/$i $i /sbin/$i-25 %{priority}
	update-alternatives --install \
	%{_mandir}/man8/$i.8%{_extension} man-$i %{_mandir}/man8/$i-25.8%{_extension} %{priority}
	[ -e /sbin/$i ] || update-alternatives --auto $i
	[ -e %{_mandir}/$i.8%{_extension} ] || update-alternatives --auto man-$i
done

if [ "$1" == 1 ]; then
	if [ -s /etc/modules.conf ]; then
		TESTING_MODPROBE_CONF=/etc/modules.conf /sbin/generate-modprobe.conf >> /etc/modprobe.conf 2> /dev/null
	fi
fi

%postun
for i in %{toalternate};do
	if [ ! -f /sbin/$i-25 ]; then
	  update-alternatives --remove $i /sbin/$i
	fi
	[ -e /sbin/$i ] || update-alternatives --auto $i

	if [ ! -f %{_mandir}/man8/$i-25.8%{_extension} ]; then
	  update-alternatives --remove man-$i %{_mandir}/man8/$i.8%{_extension}
	fi
	[ -e %{_mandir}/man8/$i.8%{_extension} ] || update-alternatives --auto man-$i
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README 
%doc TODO stress_modules.sh
%config(noreplace) /etc/modprobe.conf
%config(noreplace) /etc/modprobe.devfs
%config(noreplace) /etc/modprobe.preload
%dir /lib/module-init-tools
/lib/module-init-tools/*
/sbin/generate-modprobe.conf
/sbin/*25
%{_mandir}/*/*

%changelog
* Thu Jul 24 2003 Gtz Waschk <waschk@linux-mandrake.com> 0.9.11a-4mdk
- fix buildrequires

* Wed Jul 16 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.9.11a-3mdk
- from Andrey Borzenkov <arvidjaar@mail.ru> :
  o Preserve insmod.static - needed for initrd until nash can handle it
  o Do not strip too much from modprobe.conf.5 -> modprobe.5
  o Install modprobe.devfs
  o patch2 with mandrake modifications to modules.devfs
  o conflicts with modutils < 2.4.22-10mdk
  o probeall support in modprobe
  o patch4: remove devfsd hack now when it is fixed in devfsd. Add conflict
    with previous devfsd versions
  o source1 - default modprobe.conf
  o source2 - default modprobe.devfs
  o source3 - modprobe.default
  o source4 - modprobe.compat
  o remove patch2 (replaced by source2)
  o generate default modprobe.conf from modules.conf on install
  o put back ide-probe-mod - removed by confusion. Oops.
  o add /etc/modprobe.preload
  o fix raw devices in modprobe.devfs
  o modprobe does not support chained aliases. Rewrite modprobe.devfs to not
    use them. Add warning to modprobe.devfs and adapt examples
  o use modprobe mouse-mod; modprobe mousedev for mouse devices. 2.5 splits
    mouse support into frontend - mousedev - and backend. Backend is
    supposed to be loaded by hotplug but until then let user configure it
    in modprobe.conf as mouse-mod
  o ditto for joysticks as joystick-mod
  o remove obsolete mice from modprobe.default. Use the same trick for
    char-major-13-32 (/dev/input/mouse0) and char-major-10-1 (/dev/psaux) -
    modprobe mouse-mod; modprobe mousedev. This probably should not be done
    for /dev/input/mice as it is supposed to be for USB mostly and USB backend
    is hotplugged.
  o replace printer by usblp in modprobe.default
  o add some hints to default modprobe.conf
  o tty-ldisc-2 is serport (serial mouse port)

* Mon Apr  7 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.11a-1mdk
- Move lsmod to /sbin to don't break alternatives system (#3679)

* Fri Apr  4 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.11a-1mdk
- Bump to version 0.9.11a.

* Thu Mar 27 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.10-1mdk
- Bump to version 0.9.10.

* Thu Feb  6 2003 Chmouel Boudjnah <cuhmouel@mandrakesoft.com> 0.9.9-1mdk
- Bump to version 0.9.9.

* Wed Jan 15 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.8-2mdk
- Remove modutils package and move it to his own package.

* Tue Jan 14 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.8-1mdk
- Bump to version 0.9.8.

* Tue Jan 14 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.7-5mdk
- handle gpl symbol in module-init-tools (Petr Vandrovec).

* Tue Jan 14 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.7-4mdk
- Add modules.conf as noreplace config file.

* Fri Jan 10 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.7-3mdk
- Silly me forgot that bloody Prereq: on update-alternatives.

* Wed Jan  8 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.7-2mdk
- I promess i will go to temple every day light-up a candle and pray
  that update-alternatives will work this time 8-(.
- Generate modutils from here (not really necessary but easy to
  maintain) and try to make it live with new module-init package.
- New module-init-tools package.

* Wed Jan  8 2003 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.7-1mdk
- First version.
- Fake ChangeLog never released because of upgrade of modutils
  nevermind since i am the master of this specfile.

# end of file
